local PetSelector = PetSelector
PetSelector.debug = false
PetSelector.L = LibStub("AceLocale-3.0"):GetLocale("PetSelector")
PetSelector.click = _G.SLASH_CLICK1

--only react to game events for Hunters - not a lot of point otherwise
if select(2, UnitClass("player")) == "HUNTER" then
	PetSelector.frame:RegisterEvent("ADDON_LOADED")
	PetSelector.frame:RegisterEvent("PLAYER_LOGIN")
	PetSelector.frame:SetScript("OnEvent", function(...) PetSelector:eventHandler(...) end)
end

local L = PetSelector.L

PetSelector.PlayerLevel = UnitLevel("player")
PetSelector.Buffs = {false}
PetSelector.talents = {}
PetSelector.exclude = {}

--List of exotic pets
PetSelector.ExoticPets = {
	L["Chimaera"],
	L["Clefthoof"],	--new 6.0
	L["Core Hound"],
	L["Devilsaur"],
	L["Rhino"],
	L["Rylak"], --new 6.0
	L["Shale Spider"],
	L["Silithid"],
	L["Spirit Beast"],
	L["Worm"],
	L["Quilen"],
}

--Pet buff priority
PetSelector.PetBuffs = {
	[1] = {L["Core Hound"], L["Nether Ray"]},
	[2] = {L["Quilen"], L["Moth"], L["Crane"]},
	[3] = {L["Shale Spider"], L["Worm"], L["Dog"], L["Gorilla"], L["Riverbeast"]},
	[4] = {L["Worm"], L["Rhino"], L["Ravager"], L["Boar"], L["Bird of Prey"], L["Clefthoof"], L["Porcupine"], L["Stag"]},
	[5] = {L["Spirit Beast"], L["Cat"], L["Tallstrider"], L["Hydra"]},
	[6] = {L["Rhino"], L["Clefthoof"], L["Dragonhawk"], L["Wind Serpent"], L["Bat"], L["Basilisk"], L["Core Hound"]},
	[7] = {L["Waterstrider"], L["Raptor"], L["Devilsaur"], L["Quilen"], L["Shale Spider"], L["Wolf"]},
	[8] = {L["Silithid"], L["Silithid"], L["Rylak"], L["Bear"], L["Goat"]},
	[9] = {L["Rylak"], L["Hyena"], L["Sporebat"], L["Wasp"]},
	[10] = {L["Waterstrider"], L["Silithid"], L["Serpent"]},
}

--Spell ID of the relevant pet buff
--added pet class 1 - Ferocity, 2 - Cunning, 3 - Tenacity
PetSelector.PetInfo = {
	[1] = {L["Core Hound"], 90355, 1},			-- +30% haste for 40s
	[2] = {L["Shale Spider"], 90363, 3},		-- +5% stats
	[3] = {L["Silithid"], 90364, 2},			-- +10% stamina, +10% spell power
	[4] = {L["Raptor"], 160052, 1},				-- +5% critical strike
	[5] = {L["Serpent"], 128433, 2},			-- +10% spell power
	[6] = {L["Devilsaur"], 90309, 1},			-- +5% critical strike
	[7] = {L["Wolf"], 24604, 1},				-- +5% critical strike
	[8] = {L["Worm"], 160077, 3},				-- +5% stats, +3% versatility
	[9] = {L["Ravager"], 50518, 2},				-- +3% versatility
	[10] = {L["Dragonhawk"], 34889, 2},			-- +5% multistrike
	[11] = {L["Wind Serpent"], 24844, 2},		-- +5% multistrike
	[12] = {L["Spirit Beast"], 128997, 1},		-- +550 mastery
	[13] = {L["Cat"], 93435, 1},				-- +550 mastery
	[14] = {L["Hyena"], 128432, 1},				-- +5% haste
	[15] = {L["Rhino"], 57386, 3},				-- +5% multistrike, +3% versatility
	[16] = {L["Boar"], 35290, 3},				-- +3% versatility
	[17] = {L["Sporebat"], 135678, 2},			-- +5% haste
	[18] = {L["Fox"], 160011, 1},				-- +30% dodge
	[19] = {L["Tallstrider"], 160073, 1},		-- +550 mastery
	[20] = {L["Carrion Bird"], 24423, 1},		-- reduced healing for 10s
	[21] = {L["Bear"], 50256, 3},				-- +10% stamina
	[22] = {L["Bat"], 50519, 2},				-- +5% multistrike
	[23] = {L["Beetle"], 90339, 3},				-- -50% damage taken for 12s
	[24] = {L["Bird of Prey"], 159735, 2},		-- +3% versatility
	[25] = {L["Chimaera"], 54644, 2},			-- slows target for 5s
	[26] = {L["Crab"], 159926, 3},				-- -50% damage taken for 12s
	[27] = {L["Crocolisk"], 159936, 3},			-- -25% healing received
	[28] = {L["Dog"], 159988, 1},				-- +5% stats
	[29] = {L["Gorilla"], 160017, 3},			-- +5% stats
	[30] = {L["Monkey"], 160044, 2},			-- +30% dodge
	[31] = {L["Moth"], 159956, 1},				-- combat res
	[32] = {L["Nether Ray"], 160452, 2},		-- +30% haste for 40s
	[33] = {L["Scorpid"], 160060, 3},			-- reduced healing for 10s
	[34] = {L["Spider"], 160067, 2},			-- -50% movement speed for 6s
	[35] = {L["Turtle"], 26064, 3},				-- -50% damage for 12s
	[36] = {L["Warp Stalker"], 35346, 3},		-- -50% movement speed for 6s
	[37] = {L["Wasp"], 160074, 1},				-- +5% haste
	[38] = {L["Waterstrider"], 126309, 1},		-- +5% critical strike, +10% spellpower
	[39] = {L["Hydra"], 160039, 1},				-- +550 mastery
	[40] = {L["Quilen"], 126393, 1},			-- combat res
	[41] = {L["Goat"], 160014, 1},				-- +10% stamina
	[42] = {L["Basilisk"], 159733, 1},			-- +5% multistrike
	[43] = {L["Crane"], 159931, 1},				-- combat res
	[44] = {L["Porcupine"], 160045, 1},			-- +3% versatility
	[45] = {L["Direhorn"], 137798, 3},			-- spell deflection for 6s
	[46] = {L["Clefthoof"], 57386, 3},			-- +5% multistrike, +3% versatility
	[47] = {L["Stag"], 173035, 1},				-- +3% versatility
	[48] = {L["Riverbeast"], 159988, 3},		-- +5% stats
	[49] = {L["Rylak"], 160003, 2},				-- +5% haste, +10% stamina
}

--Raid buffs in priority order, who can provide them
--and what talent spec, talents they need
-- {class, tree, spellid, hordespellid}
PetSelector.PlayerBuffs = {
	[1] = {	-- Burst haste
		{"SHAMAN", nil, 32182, 2825},
		{"MAGE", nil, 80353},
		{"HUNTER", nil, L["Nether Ray"]},
	},
	[2] = { -- Combat Res
		{"DEATHKNIGHT", nil, 61999},
		{"DRUID", nil, 20484},
		{"WARLOCK", nil, 20707},
		{"HUNTER", nil, L["Crane"]},
	},
	[3] = { -- +5% Strength, agility, intellect
		{"DRUID", nil, 1126},
		{"MONK", 3, 115921},
		{"MONK", nil, 116781},
		{"PALADIN", nil, 20217},
		{"HUNTER", nil, L["Gorilla"]},
	},
	[4] = { -- +3% versatility
		{"DEATHKNIGHT", nil, 55610},
		{"PALADIN", 3, 167187},
		{"WARRIOR", nil, 167188},
		{"HUNTER", nil, L["Porcupine"]},
	},
	[5] = { -- +550 mastery
		{"PALADIN", nil, 19740},
		{"SHAMAN", 2, 116956},
		{"DEATHKNIGHT", 1, 155522},
		{"DRUID", nil, 24907},
		{"HUNTER", nil, L["Cat"]},
	},
	[6] = { -- +5% multistrike
		{"MONK", 2, 166916},
		{"PRIEST", nil, 49868},
		{"ROGUE", nil, 113742},
		{"WARLOCK", nil, 109773},
		{"HUNTER", nil, L["Fox"]},
	},
	[7] = { -- +5% Critical Strike
		{"DRUID", 2, 17007},
		{"DRUID", 3, 17007},
		{"MAGE", nil, 1459},
		{"MAGE", nil, 61316},
		{"MONK", 3, 116781},
		{"HUNTER", nil, L["Wolf"]},
	},
	[8] = { -- +10% Stamina
		{"PRIEST", nil, 21562},
		{"WARLOCK", nil, 166928},
		{"WARRIOR", nil, 469},
		{"HUNTER", nil, L["Goat"]},
	},
	[9] = { -- +5% Haste
		{"DEATHKNIGHT", 2, 55610},
		{"DEATHKNIGHT", 3, 55610},
		{"ROGUE", nil, 113742},
		{"PRIEST", nil, 49868},
		{"SHAMAN", nil, 116956},
		{"HUNTER", nil, L["Wasp"]},
	},
	[10] = { -- +10% Spell Power
		{"MAGE", nil, 1459},
		{"MAGE", nil, 61316},
		{"WARLOCK", nil, 109773},
		{"HUNTER", nil, L["Waterstrider"]},
	},
}

StaticPopupDialogs["PETSELECTOR_STABLED"] = {
	text = "",
	button1 = _G.OKAY,
	timeout = 0,
	whileDead = 1,
	hideOnEscape = 1
}

StaticPopupDialogs["PETSELECTOR_MACROS"] = {
	text = L["You have too many character specific macros, Pet Selector cannot create a new one"],
	button1 = _G.OKAY,
	timeout = 0,
	whileDead = 1,
	hideOnEscape = 1
}